// ============================================================================
// CBP + FBO = MAS22 Simulation Framework
// 20-12-21
// 28-01-22
//
// ============================================================================

#include "MAS22_Actor.h"
#include "MAS22_Structs.h"

// Sets default values
AMAS22_Actor::AMAS22_Actor()
{
 	// Set this actor to call Tick() every frame.  You can turn this off to improve performance if you don't need it.
	PrimaryActorTick.bCanEverTick = false;

}

void AMAS22_Actor::ActorInitialize() {
	GEngine->AddOnScreenDebugMessage(-1, 4.0f, FColor::Purple,
		FString::Printf(TEXT(">>>> AMAS22_Actor::ActorInitialize(): called")));

	GetWorldTimerManager().SetTimer(TimerHandle, this, &AMAS22_Actor::ComputeDT, dT, true);
}

void AMAS22_Actor::SetInitialConditions() {
	GEngine->AddOnScreenDebugMessage(-1, 4.0f, FColor::Purple,
		FString::Printf(TEXT(">>>> AMAS22_Actor::SetInitialConditions(): called")));

	time = 0;
}

// (12) -------------------------
void AMAS22_Actor::SetParams(double paramArray[]) {

}

void AMAS22_Actor::Message() {

}

void AMAS22_Actor::SetRunning() {
	GEngine->AddOnScreenDebugMessage(-1, 4.0f, FColor::Purple,
		FString::Printf(TEXT(">>>> AMAS22_Actor::SetRunning(): called")));

	bRunning = true;
}

void AMAS22_Actor::ComputeDT() {
	static bool dispDebug = true;
	if (dispDebug == true) {
		GEngine->AddOnScreenDebugMessage(-1, 4.0f, FColor::Purple,
			FString::Printf(TEXT(">>>> AMAS22_Actor::ComputeDT(): called: time = %f"), time));
		dispDebug = false;
	}
}

void AMAS22_Actor::Computation() {
	static bool dispDebug = true;
	if (dispDebug == true) {
		GEngine->AddOnScreenDebugMessage(-1, 4.0f, FColor::Purple,
			FString::Printf(TEXT(">>>> AMAS22_Actor::Computation(): called: time = %f"), time));
		dispDebug = false;
	}
}

void AMAS22_Actor::BuildHUDLines() {

}


void AMAS22_Actor::Visualization(float deltaTime) {

}


void AMAS22_Actor::GetHUDLines(TArray<HUDLine>** plines) {
	static bool dispDebug = true;
	
	*plines = &HUDLines;

	int len = (**plines).Num();
	if (dispDebug == true) {
		GEngine->AddOnScreenDebugMessage(-1, 4.0f, FColor::Purple,
			FString::Printf(TEXT(">>>> AMAS22_Actor::GetHUDLines array length = %d"), len));

		FString message = (**plines)[0].message;

		GEngine->AddOnScreenDebugMessage(-1, 4.0f, FColor::Purple ,
			FString::Printf(TEXT(">>>> AMAS22_Actor::GetHUDLines array message 0 = %s"), *message));

		dispDebug = false;
	}
}

void AMAS22_Actor::LogData() {

}

void AMAS22_Actor::EndPlay(const EEndPlayReason::Type EndPlayReason) {
	Super::EndPlay(EndPlayReason);

	GetWorldTimerManager().ClearTimer(TimerHandle);
}

// (12) Solver Functions -------------------------------- 28-01-22 ----------
void AMAS22_Actor::InitializeSolver() {

}

void AMAS22_Actor::Euler(double DeltaTime) {

}

void AMAS22_Actor::EulerCromer(double DeltaTime) {

}

void AMAS22_Actor::RungeKutta(double DeltaTime) {

}

void AMAS22_Actor::RungeKuttaFehlberg(double DeltaTime) {

}



