// ============================================================================
// CBP + FBO = MAS22 Simulation Framework
// 20-12-21
//
// ============================================================================

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/Pawn.h"
#include "UObject/ObjectMacros.h"
#include "GameFramework/DefaultPawn.h"
#include "MAS22_Pawn.generated.h"

UCLASS()
class MAS22_SCIENCEPARK_API AMAS22_Pawn : public ADefaultPawn
{
	GENERATED_BODY()
		UPROPERTY(VisibleDefaultsOnly)
		class UCapsuleComponent* CapsuleCollider;

public:
	// Sets default values for this pawn's properties
	AMAS22_Pawn();
	static FName CollCompName;

	class UCameraComponent* FirstPersonCameraComponent;

protected:
	// Called when the game starts or when spawned
	virtual void BeginPlay() override;

	UPROPERTY(EditDefaultsOnly, BlueprintReadWrite, Category = "Movement")
		float speed;

	UPROPERTY(VisibleAnywhere, BlueprintReadOnly, Category = "Movement")
		FVector2D direction;

public:	
	// Called every frame
	virtual void Tick(float DeltaTime) override;

	// Called to bind functionality to input
	virtual void SetupPlayerInputComponent(class UInputComponent* PlayerInputComponent) override;

};
