// ============================================================================
// CBP + FBO = MAS22 Simulation Framework
// 20-12-21
//
// ============================================================================


#include "MAS22_PlayerController.h"
#include "SlateBasics.h"
//#include "SGreetings.h"
#include "SlateOptMacros.h"
//#include "SButton.h"
//#include "STextBlock.h"
#include "MAS22_Pawn.h"
#include "Kismet/GameplayStatics.h"
#include "Kismet/KismetSystemLibrary.h"
#include "DrawDebugHelpers.h"
#include "MAS22_Actor.h"
#include "MAS22_HUD.h"
#include "MAS22_Structs.h"

AMAS22_PlayerController::AMAS22_PlayerController() :APlayerController() {
	PrimaryActorTick.bCanEverTick = true;
}

void AMAS22_PlayerController::BeginPlay() {

	Super::BeginPlay();

	//Possess(Cast<AMAS22_Pawn>(AMAS22_Pawn));

	Pawn = Cast<AMAS22_Pawn>(GetPawn());
	if (!Pawn) {
		GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Blue,
			FString::Printf(TEXT("NO PAWN")));
	}

	// Started a timer to call Update()
	GetWorldTimerManager().SetTimer(TimerHandle, this,
		&AMAS22_PlayerController::Update, 1.0, true);

	// Places time as a UI element
	// Lambda allows for dynamic updating
	TSharedRef<SVerticalBox> widget1 = SNew(SVerticalBox)
		+ SVerticalBox::Slot().HAlign(HAlign_Left).VAlign(VAlign_Center)[
			SNew(SButton).Content()[
				SNew(STextBlock).Text_Lambda([this] {return(FText::AsNumber(itn)); })
			]
		];

	GEngine->GameViewport->AddViewportWidgetForPlayer(GetLocalPlayer(), widget1, 1);

	//AMAS22_PlayerController* Pcont = 
	HUD = Cast<AMAS22_HUD>(this->GetHUD());

	if (!HUD) {
		GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Blue,
			FString::Printf(TEXT("NO HUD")));

		return;
	}

}

void AMAS22_PlayerController::Update() {

	itn++;

	HUD->SetTo(itn);
}

void AMAS22_PlayerController::SetupInputComponent() {
	Super::SetupInputComponent();

	GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Blue,
		FString::Printf(TEXT("AMAS22_PlayerController::SetupInputComponent()")));

	InputComponent->BindAction("Fire", IE_Pressed, this, &AMAS22_PlayerController::ActivateObject);
	InputComponent->BindAction("E_Key", IE_Pressed, this, &AMAS22_PlayerController::E_Pressed);
}

void AMAS22_PlayerController::E_Pressed() {
	GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Blue,
		FString::Printf(TEXT("AMAS22_PlayerController::E_Pressed()")));
}

void AMAS22_PlayerController::ActivateObject() {
	GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Blue,
		FString::Printf(TEXT("AMAS22_PlayerController::ActivateObject()")));

	//if (!GetOwner()) {
	//	GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Red,
	//		FString::Printf(TEXT("NO PAWN")));
	//}

	FPCC = Pawn->FirstPersonCameraComponent;

	FVector start = FPCC->GetComponentLocation();

	FVector end = start + FPCC->GetForwardVector() * 100000000;

	DrawDebugLine(GetWorld(), start, end, FColor::Purple, true, 1.0f, (uint8)'\000', 5.0f);

	TEnumAsByte<ETraceTypeQuery> Actor = ETraceTypeQuery::TraceTypeQuery1;
	TArray<AActor*> Ignored;
	Ignored.Add(this);
	FHitResult Hit(ForceInit);
	bool bHitActor = UKismetSystemLibrary::LineTraceSingle(
		GetWorld(), start, end, Actor, false, Ignored, EDrawDebugTrace::ForDuration, Hit, true);

	if (bHitActor) {
		//FString HitActorName = Hit.Actor->GetName();
		GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Blue,
			FString::Printf(TEXT("%s"), *Hit.Actor->GetName()));

		if (Hit.Actor->IsA(AMAS22_Actor::StaticClass())) {
			GEngine->AddOnScreenDebugMessage(-1, 5.0f, FColor::Blue,
				FString::Printf(TEXT("Turbine found")));

			AMAS22_Actor* Masac = Cast<AMAS22_Actor>(Hit.GetActor());
			Masac->SetRunning();

			HUD->SetSelectedActor(Masac);
		}
	}

}

