// ============================================================================
// CBP + FBO = MAS22 Simulation Framework
// 30-01-22
// rhs_Monster_Truck.cpp
// 09-02-21 changed sign of x in airs supension calculation
// ============================================================================

#include "rhs_Monster_Truck.h"
#include "GameFramework/Actor.h" // for onscreen messages
//#include "GenericPlatform/GenericPlatformMath.h"  // For Pow
#include <cmath>

double pMass;
double pSpringConstant;
double pDamping;
//(22) -------------
double A;
double x0;
double k;
 
// (21) --------------------------------------
double appliedForce=0;
double floorPlateDispZ;

	void setParams(double params[]) {
		pMass = params[0];
		pSpringConstant = params[1];
		pDamping = params[2];
		A = params[3];
		x0 = params[4];
		k = params[5];
		//GEngine->AddOnScreenDebugMessage(-1, 10.0f, FColor::Yellow,
		//	FString::Printf(TEXT("pDamping = %f, pMass = %f"), pDamping,pMass));
		//double test1 = pow(2, 1.5);
		//double test2 = pow(-2, 1.5);
		//GEngine->AddOnScreenDebugMessage(-1, 10.0f, FColor::Yellow,
		//	FString::Printf(TEXT("Pow test1 =  %f, Pow test2 = %f"), test1,test2));

	}

	void applyStaticForce(double value) {
		appliedForce = value;
	}
	void applyFloorPlateDispZ(double value) {
		floorPlateDispZ = value;
	}

	void rhs_Monster_Truck(double t, double u[], double dudt[]){

		// (21) -------------------------
		// applied force
		dudt[0] = u[1];
		dudt[1] = -1.0 * (pSpringConstant / pMass) * (u[0] - floorPlateDispZ) - pDamping * u[1] + appliedForce;

	}

	// (22) ----------------------------
	void rhs_Monster_Truck_Air(double t, double u[], double dudt[]) {

		// (21) -------------------------		
		//GEngine->AddOnScreenDebugMessage(-1, 10.0f, FColor::Yellow,
		//	FString::Printf(TEXT("floorPlate %f, u[0] = %f"), floorPlateDispZ, u[0]));

		double denom = A * (x0 - floorPlateDispZ + u[0]);
		double effectiveK = (k * A) / (FMath::Pow(denom,1.30) ) - 5500;
		//GEngine->AddOnScreenDebugMessage(-1, 3.0f, FColor::Yellow,
		//	FString::Printf(TEXT("effectiveK = %f"), effectiveK));

		dudt[0] = u[1];
		dudt[1] = effectiveK / pMass - pDamping * u[1] + appliedForce;

	}


