// ============================================================================
// CBP + FBO = MAS22 Simulation Framework
// 05-02-22
// rhs_SkyMaster.cpp
// ============================================================================

#include "rhs_SkyMaster.h"
#include "GameFramework/Actor.h" // for onscreen messages
//#include "GenericPlatform/GenericPlatformMath.h"  // For Pow
//#include <cmath>

// Parameters -------------------------
double mass;
double armLength;
double gravity;
double damping;

// Local variables --------------------
double torque;
double torqueM;
double theta;
double omega;

	void setParams_SM(double params[]) {
		mass = params[0];
		armLength = params[1];
		gravity = params[2];
		damping = params[3];
	}

	void rhs_SkyMaster(double t, double u[], double dudt[]){
		theta = u[0];
		omega = u[1];
		torque = torqueM - mass * gravity * armLength * sin(theta) - damping * omega;
		dudt[0] = u[1];
		dudt[1] = torque / (mass * armLength * armLength);
	}

	void applyPeriodicDrive(double val) {
		torqueM = val;
	}


